import H.*;
import java.awt.Color;

class DrawingGrid extends Grid
{
    public DrawingGrid(int nrows, int ncols)
    {
        super(nrows,ncols); // initializes all of the squares to white
    }   
    
    public void nextStep()
    {
        ;
    }
    
    public void drawRect(int ulx, int uly, int width, int height, Color c)
    {
        // simply place the color into the appropriate spot ... 
        // let's do some error checking while we're at it!
        if (ulx < 0 || uly < 0 || ulx+width > m_ncols || uly+height > m_nrows)
        {
            H.pl("in drawRect(" + ulx + "," + uly + "," + width + "," + height + ",<color>)");
            H.pl("  the input arguments go out of bounds!");
            H.pl("  Make sure that");
            H.pl("     " + ulx + " >= 0 (upper-left x must be nonnegative)");
            H.pl("     " + uly + " >= 0 (upper-left y must be nonnegative)");
            H.pl("     " + (ulx+width) + " <= " + m_ncols + " (upper-left x plus width must not be too big");
            H.pl("     " + (uly+height) + " <= " + m_nrows + " (upper-left y plus height must not be too big");
            H.pl("\nThis rectangle request is being ignored...\n");
            return;                        
        }
        
        // ok, so everything is in bounds...
        
        for (int row=uly ; row < uly+height ; ++row)
        {
            for (int col=ulx ; col < ulx+width ; ++col)
            {
                m_colors[row][col] = c;
            }                                
        }
        
        // that's it!
        
        return;
    }
}