/*
 * This is the Harvey Mudd input/output convenience class
 *
 * Zach Dodds, Fall 2003
 */
 
package H;

import java.io.*;
import java.lang.*;
import H.*;

public class H 
{
    public static HMCInput in = new HMCInput(java.lang.System.in);
    public static HMCOutput out = new HMCOutput(java.lang.System.out);
    
    static HMCOutput input_out = out;
    
    static HMCInput console_in = in;
    static HMCOutput console_out = out;
    
    static int dummyInt = HMCSupport.DummyFunctionForPrinting();
    
    /*
     * clear the screen by printing 50 blank lines
     */
    public static void cls()
    {
    	for (int i=0 ; i<50 ; ++i)
    	{
    		H.pl();
    	}
    }
    
    public static boolean outputAndInputToFile(String fileName)
    {
        boolean ret =  outputToFile(fileName,false);   
                // false means replace the file
                // rather than append to the end of it
        H.input_out = out;
        return ret;
                                               
    }    

    public static boolean outputToFile(String fileName)
    {
        return outputToFile(fileName,false);   // false means replace the file
                                               // rather than append to the end of it
    }
    
    public static boolean inputToFile(String fileName)
    {
        FileOutputStream f = null;
        try
        {
            f = new FileOutputStream(fileName,false); // false means replace the file, if it exists
            PrintStream P = new PrintStream(f);
            input_out = new HMCOutput(P);
            return true;
        }
        catch (Exception e)
        {
            System.out.println("There was a problem opening the file " + fileName);
            System.out.println("H.out will remain the console output.\n\n");
            e.printStackTrace();
        }
        return false;
    }
    
    public static boolean outputToFile(String fileName, boolean append)
    {
        FileOutputStream f = null;
        try
        {
            f = new FileOutputStream(fileName,append);
            PrintStream P = new PrintStream(f);
            out = new HMCOutput(P);
            return true;
        }
        catch (Exception e)
        {
            System.out.println("There was a problem opening the file " + fileName);
            System.out.println("H.out will remain the console output.\n\n");
            e.printStackTrace();
        }
        return false;
    }
    
    public static boolean inputFromFile(String fileName)
    {   
        FileInputStream I = null;
        try
        {
            I = new FileInputStream(fileName);
            in = new HMCInput(I);
            return true;
        }
        catch (Exception e)
        {
            System.out.println("There was a problem opening the file " + fileName);
            System.out.println("Does the file " + fileName + " exist?");
            System.out.println("H.in will remain the console input.\n\n");
            e.printStackTrace();
        }
        return false;
    }
    
    public static boolean outputToConsole()
    {
        out = console_out;
        return true;
    }
    
    public static boolean inputToConsole()
    {
        input_out = console_out;
        return true;
    }
    
    public static boolean inputFromConsole()
    {
        in = console_in;
        return true;
    }
    
    /*
     * shortcuts -- these allow one to type
     *
     *  H.p(<something>) or H.pl(<something>)
     *
     * instead of the longer versions:
     *
     *  H.out.print(<something>)   or HMCSupport.out.print(<something>) or
     *  H.out.println(<something>) or HMCSupport.out.println(<something>) or
     */
    
    public static void p(String o)    { H.out.print(o); }
    public static void p(byte o)      { H.out.print(o); }
    public static void p(Byte o)      { H.out.print(o); }    
    public static void p(boolean o)   { H.out.print(o); }
    public static void p(short o)     { H.out.print(o); }
    public static void p(Short o)     { H.out.print(o); }    
    public static void p(char o)      { H.out.print(o); }
    public static void p(int o)       { H.out.print(o); }
    public static void p(Integer o)   { H.out.print(o); }
    public static void p(float o)     { H.out.print(o); }
    public static void p(Float o)     { H.out.print(o); }
    public static void p(double o)    { H.out.print(o); }
    public static void p(Double o)    { H.out.print(o); }
    public static void p(long o)      { H.out.print(o); }
    public static void p(Long o)      { H.out.print(o); }
    public static void p(Object o)    { H.out.print(o); }
    
    public static void pl(String o)    { H.out.println(o); }
    public static void pl(byte o)      { H.out.println(o); }
    public static void pl(Byte o)      { H.out.println(o); }    
    public static void pl(boolean o)   { H.out.println(o); }
    public static void pl(short o)     { H.out.println(o); }
    public static void pl(Short o)     { H.out.println(o); }     
    public static void pl(char o)      { H.out.println(o); }
    public static void pl(int o)       { H.out.println(o); }
    public static void pl(Integer o)   { H.out.println(o); }
    public static void pl(float o)     { H.out.println(o); }
    public static void pl(Float o)     { H.out.println(o); }
    public static void pl(double o)    { H.out.println(o); }
    public static void pl(Double o)    { H.out.println(o); }
    public static void pl(long o)      { H.out.println(o); }
    public static void pl(Long o)      { H.out.println(o); }
    public static void pl(Object o)    { H.out.println(o); }   
    public static void pl()            { H.out.println(); }  
    
    public static int    ni()          { return H.in.nextInt(); }
    public static long   nlong()       { return H.in.nextLong(); }
    public static float  nf()          { return H.in.nextFloat(); }
    public static double nd()          { return H.in.nextDouble(); }
    public static String nw()          { return H.in.nextWord(); }
    public static String nl()          { return H.in.nextLine(); } 
    public static char   nc()          { return H.in.nextChar(); }
    public static char   nanyc()       { return H.in.nextAnyChar(); }
  
    public static void main(String[] sa)
    {
        //H.inputFromFile("input2.txt");
        //H.outputAndInputToFile("output.txt");
        //H.outputToFile("output.txt");
        //H.inputToFile("input3.txt");
        
        H.pl("Hello, World! What time is it? ");
        int x2 = H.ni();
        H.pl("x is " + x2);
        
        String s,t,u,v;
        char y;
        char c = 'a';
        while (c>='a') { // capital letters quit...
        
            H.p("Type a char (uc to quit), word, line, char, word, line: ");
	        c = H.nc();
	        s = H.nw();
	        t = H.nl();
	        y = H.nc();
	        u = H.nw();
	        v = H.nl();
	        
			H.pl("char is " + c);
			H.pl("word is " + s);
	        H.pl("line is " + t);
	        H.pl("char is " + y);
	        H.pl("word is " + u);
	        H.pl("line is " + v);
	    }
        
        H.pl("\n\n");
        
        H.pl("Getting a string");
        String s3 = H.nw();
        H.pl("s3 is " + s3);
        
        System.exit(0);
        

        H.p('H');
        H.p("i #1  ");
        H.pl("Hi #2  ");
        
        int i = 5; // i =  H.in.nextInt();
        long l = 7L; // l =  H.in.nextLong();
        double d = 3.14159;  // d = H.in.nextDouble();
        
        H.pl("int i is " + i);
        H.pl("long l is " + l);
        H.pl("double d is " + d);
        H.pl("22/7 is " + (22/7.));
        H.pl(true);
        H.pl(false);
        H.pl();
        
        double[][] D = { {1, 2, 3}, {4, 5, 6}, {7, 8, 9} };
        
        H.out.setWidth(8);
        H.out.setRightJustify();
        H.out.setPrecision(2);
        H.out.setFixed(true);
        H.out.println();
        for (int r=0 ; r<D.length ; ++r)
        {
            for (int col=0 ; col<D[r].length ; ++col)
            {
                H.p(D[r][col]);
            }
            H.pl();
        }
        H.pl();
        
        H.out.setWidth(0);
        H.out.setLeftJustify();
        H.out.setPrecision(0);
        H.out.setFixed(false);
        H.outputToConsole();
        H.out.println("Wow! it worked...");
    }



}





