import java.awt.*;
import java.awt.event.*;
import java.util.LinkedList;
import javax.swing.*;
import java.io.FileReader;
import java.io.BufferedReader;
import java.io.StreamTokenizer;
import H.*;

class Drawable
{
    protected static JPanel m_canvas = null;
    protected static Graphics2D g;
    protected static int height;
    protected static int width;
    
    private static LinkedList screenObjects = new LinkedList();
    
    
    static public void setPanel(JPanel canvasIn)
    {
        m_canvas = canvasIn;
        resizeHandler();   // if we have a new panel, it's a new size!
    }
    
    static public void resizeHandler()
    {
        if (m_canvas == null) return;  // nothing's there yet!
        
        //H.pl("The window has been resized... adjusting...");  
        height = m_canvas.getHeight();
        width = m_canvas.getWidth();      
        
        int listlen = screenObjects.size();
        
        for (int i=0 ; i<listlen ; ++i)
        {
            Drawable d = (Drawable)(screenObjects.get(i));
            d.handleResizeEvent();
        }
        // redraw will be handled by Swing
    }
    
    static public void nextStepList()
    {
        int listlen = screenObjects.size();
        
        for (int i=0 ; i<listlen ; ++i)
        {
            Drawable d = (Drawable)(screenObjects.get(i));
            d.nextStep();
        }
    }
    
    static public void drawList(Graphics g_in)
    {
        if (g_in instanceof Graphics2D)  
        {
            g = (Graphics2D)(g_in);   
        }
        else 
        {
            H.pl("Not a Graphics2D!");
            return;
        }
        
        int listlen = screenObjects.size();
        
        for (int i=0 ; i<listlen ; ++i)
        {
            Drawable d = (Drawable)(screenObjects.get(i));
            d.draw();
        }
    }
    

    public Drawable()
    {
        register();
    } 
    
    protected void register()
    {
        Drawable.screenObjects.add(this);
    }
    
    public void draw()
    {
        ;
    }
    
    public void nextStep()
    {
        ;
    }
    
    public void handleResizeEvent()
    {
        ;
    }
}
	