import java.awt.*;
import java.awt.event.*;
import java.util.LinkedList;
import javax.swing.*;
import java.io.FileReader;
import java.io.BufferedReader;
import java.io.StreamTokenizer;
import H.*;

class OuterFrame extends JFrame
{    
    private JPanel centerPanel = new MyPanel();
    private JPanel southPanel = new JPanel();
    private JButton button1 = new JButton();
    private JButton button2 = new JButton();
    private static String[] mapStrings = { "Map 0","Map 1","Map 2","Map 3","Map 4","Map 5","Map 6" };
    private JComboBox mapbox = new JComboBox(mapStrings);
    
    public static MyUpdater updater = new MyUpdater();
    
    public OuterFrame() 
    {         
        addListeners();
        initFrame();
    }
    
    public OuterFrame(Color c)   // specify the background color of the center panel
    {
        addListeners();
        initFrame();
        centerPanel.setBackground(c);
    }
    
    private void addListeners()
    {
        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                dispose();
                System.exit(0);
            }
        });
        
        addComponentListener(new ComponentAdapter() {
            public void componentResized(ComponentEvent e) {
                Drawable.resizeHandler();
            }
        });
    }
    
    public void setComboBoxItem(int itemIndex)
    {
        if (itemIndex >=0 && itemIndex <= 6)
            this.mapbox.setSelectedIndex(itemIndex);
    }

    private void initFrame() 
    {
        H.pl("Initializing the GUI ...");

        this.setSize(400, 400);
        this.setTitle("CS5AppGr");
        
        // this.getContentPane().setLayout(null);
        
        // fix up our center panel
        centerPanel.setVisible(true);
        centerPanel.setBackground(Color.black);
        
        // fix up our south panel
        southPanel.setVisible(true);
        southPanel.setBackground(Color.yellow);
        
        // objects to be added to the south panel
        button1.setVisible(true);
        button1.setText("Go/Stop");
        //button1.setBackground(Color.WHITE);
        button1.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                //H.pl("Button pressed!");
                updater.toggle();
            }
        });
        
        button2.setVisible(true);
        button2.setText("Step");
        button2.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                //H.pl("Button pressed!");
                updater.step(1);
            }
        });
        
        mapbox.setVisible(true);
        mapbox.setSelectedIndex(0);
        mapbox.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                JComboBox cb = (JComboBox)e.getSource();
                String s = (String)cb.getSelectedItem();
                //H.pl("String = "+ s);
                String[] L = s.split("\\s+");
                int mapnumber = Integer.parseInt(L[1]);
                H.pl("Changing to map # " + mapnumber);
                if (mapnumber < 0 || mapnumber > 6)
                  mapnumber = 1;
                CS5AppGr.p.changeMap(mapnumber);
                updater.step(1);
            }
        });
        
        
        
        // add objects to the south panel
        southPanel.add(button1);
        southPanel.add(button2);
        southPanel.add(mapbox);
        
        // add panels to the enclosing frame (OuterFrame)
        this.getContentPane().add(centerPanel,BorderLayout.CENTER);
        this.getContentPane().add(southPanel,BorderLayout.SOUTH);
        this.setVisible(true);
        
        /*
         * start the threading object (updater)
         */
        updater.setPanel(centerPanel);
        updater.setSleepTime(5);
        updater.start();
        
        /*
         * associate the centerPanel with our objects to be drawn
         */
        Drawable.setPanel(centerPanel);
    }
}
	